// CellularAutomataDlg.cpp : implementation file
//



#include "stdafx.h"
#include "CellularAutomata.h"
#include "CellularAutomataDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define BIT(x, index) (x && (1 << index))

/////////////////////////////////////////////////////////////////////////////
// CCellularAutomataDlg dialog

CCellularAutomataDlg::CCellularAutomataDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCellularAutomataDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCellularAutomataDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCellularAutomataDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCellularAutomataDlg)
	DDX_Control(pDX, IDC_DECIMAL, m_decimal);
	DDX_Control(pDX, IDC_BINARY, m_binary);
	DDX_Control(pDX, IDC_HEIGHT, m_height);
	DDX_Control(pDX, IDC_WIDTH, m_width);
	DDX_Control(pDX, IDC_RULE, m_rule);
	DDX_Control(pDX, IDC_IMAGE, m_Image);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCellularAutomataDlg, CDialog)
	//{{AFX_MSG_MAP(CCellularAutomataDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GENERATE, OnGenerate)
	ON_BN_CLICKED(IDC_BINARY, OnBinary)
	ON_BN_CLICKED(IDC_DECIMAL, OnDecimal)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCellularAutomataDlg message handlers

BOOL CCellularAutomataDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_decimal.SetCheck(1);
	m_width.SetWindowText("42");
	m_height.SetWindowText("20");
	m_rule.SetWindowText("30");
	RECT rect;
	m_Image.GetClientRect(&rect);
	CDC *dc = GetDC();
	bmp.CreateCompatibleBitmap(dc, rect.right, rect.bottom);
	bmpDC.CreateCompatibleDC(dc);
	bmpDC.SelectObject(&bmp);

	CBrush white((COLORREF)0x00FFFFFF);
	bmpDC.FillRect(&rect, &white);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCellularAutomataDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		RECT rect1;
		m_Image.GetClientRect(&rect1);
		CDC *dc = m_Image.GetDC();
		dc->BitBlt(2, 2, rect1.right-4, rect1.bottom-4, &bmpDC, 2, 2, SRCCOPY);
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCellularAutomataDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CCellularAutomataDlg::OnGenerate() 
{
	CString strWidth, strHeight, strRule;

	int rule, width, height;


	int realWidth = 500;
	

	CDC * dc = m_Image.GetDC();

	int i,j;

	m_width.GetWindowText(strWidth);
	m_height.GetWindowText(strHeight);
	m_rule.GetWindowText(strRule);
	if(m_decimal.GetCheck())
	{
		rule = strtol(strRule, 0, 10);
	} else {
		rule = strtol(strRule, 0, 2);
	}

	height = strtol(strHeight, 0, 10);
	width = strtol(strWidth, 0, 10);


	int startCol = realWidth/2 - width/2;

	int **map;
	map = new int*[height];
	for(i=0; i<height; i++)
		map[i] = new int[realWidth];
	
	for(i=0; i<height; i++)
		for(j=0; j<realWidth; j++)
		{
			map[i][j] = 0;
		}


	map[0][realWidth/2] = 1;

	for(i=1; i<height; i++)
	{
		for(j=1; j<(realWidth-1); j++)
		{
			int index = 0;
			index += map[i-1][j-1] * 4;
			index += map[i-1][j] * 2;
			index += map[i-1][j+1] * 1;

			map[i][j] = (rule & (1 << index)) >> index;
		}
	}


	RECT rect1;
	m_Image.GetClientRect(&rect1);

	float cellWidth = float(rect1.right-4) / width;
	float cellHeight = float(rect1.bottom-4)  / height;

	CBrush white((COLORREF)0x00FFFFFF);
	CBrush black((COLORREF)0x00000000);

	bmpDC.FillRect(&rect1, &white);
	for(i=0; i<height; i++)
	{
		for(j=0; j<width; j++)
		{
			RECT rect;
			rect.top = i * cellHeight + 2;
			rect.left = j * cellWidth + 2;
			rect.bottom = (i + 1) * cellHeight + 2;
			rect.right = (j + 1) * cellWidth + 2;


			if(map[i][j+startCol])
				bmpDC.FillRect(&rect, &black);
			else
				bmpDC.FillRect(&rect, &white);
		}
	}

	
	dc->BitBlt(2, 2, rect1.right-4, rect1.bottom-4, &bmpDC, 2, 2, SRCCOPY);

	
	for(i=0; i<height; i++)
		delete []map[i];
	delete []map;
}

void CCellularAutomataDlg::OnBinary() 
{
	// TODO: Add your control notification handler code here
	m_decimal.SetCheck(0);
}

void CCellularAutomataDlg::OnDecimal() 
{
	m_binary.SetCheck(0);	
}
